/*********************************************************************
{\[XXgу\tgEFÁACZXt[łB
pAҏWAĔzzRɍs܂A쌠\̉ς͋֎~܂B

                               Copyright (c) 2009-2010 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/

//	7ZOgLED hCo Am[hRp
//
//		Copyright (c) 2009-2010 Wataru KUNINO
//
//			o[W		0.5 10/07/16
//
//			gp}CR	PIC16F688
//			RpC		HI-TECH Software PICC PRO 9.60
//			Configure		30D4

/*
6pin I/F
	1  MODE(Vpp)	[hؑ(H:Jn L:[hؑ)  
	2  VDD			DC5Vd  
	3  GND			OEh(0V)  
	4  ICSPDAT		PICkit2f[^p  
	5  ICSPCLK		PICkit2NbNp  
	6  AN6			AiO(0V`dd܂)  
	
	MODEтɃ[hςB
	Ń[hŒ肷B(ɓdꂽƂ̃[h)
	
	mode=1 dd5Vɂ	0`5ṼAiO͂郂[hB
	mode=5 d1/3ɕ	0`15ṼAiO͂郂[hB
*/

#include <htc.h>
	__CONFIG(INTIO & WDTDIS & PWRTDIS & MCLRDIS & UNPROTECT & BORDIS & IESODIS & FCMDIS);
	__IDLOC(F688);
#define _XTAL_FREQ	4000000	// 4MHz
#define SEG7_P_a	RA0
#define SEG7_P_b	RA1
#define SEG7_P_c	RA4
#define SEG7_P_d	RA5
#define SEG7_P_e	RC5
#define SEG7_P_f	RC1
#define SEG7_P_g	RC4
#define SEG7_P_dp	RC3
#define SEG7_P_0	RC0
#define SEG7_P_1	RA2
#define KEY_P		RA3
#define EEPROM_A_MODE	00		// EEPROMAhX \[hݒl
#define MODE_NUM	5			// \[h

const char LEDDigit[] = {
/*  c2x7Seg.c - Roll through 16 Digits on a Dual 7 Segment LED Display
myke predko
04.12.09
*/
//    abcdefg - LED Segment
    0b0000001,          //  "0"       a   
    0b1001111,          //  "1"      ---  
    0b0010010,          //  "2"    f|   |b
    0b0000110,          //  "3"      ---  
    0b1001100,          //  "4"    e| g |c
    0b0100100,          //  "5"      ---  
    0b0100000,          //  "6"       d   dp
    0b0001101,          //  "7" ύX
    0b0000000,          //  "8"
    0b0000100,          //  "9" ύX
    0b0001000,          //  "A"
    0b1100000,          //  "b"
    0b1110010,          //  "c" ύX
    0b1000010,          //  "d"
    0b0110000,          //  "E"
    0b0111000,          //  "F"
    0b0100001,          // ǉ 0x10 "G"
    0b1101000,          // ǉ 0x11 "h"
    0b1101111,          // ǉ 0x12 "i"
    0b1000011,          // ǉ 0x13 "J"
    0b0101000,          // ǉ 0x14 "k"
    0b1110001,          // ǉ 0x15 "L"
    0b0001001,          // ǉ 0x16 "M"
    0b1101010,          // ǉ 0x17 "n"
    0b1100010,          // ǉ 0x18 "o"
    0b0011000,          // ǉ 0x19 "P"
    0b0001100,          // ǉ 0x1A "q"
    0b1111010,          // ǉ	0x1B "r"
    0b1100100,          // ǉ	0x1C "s
    0b1110000,          // ǉ	0x1D "t"
    0b1100011,          // ǉ	0x1E "u"
    0b1011000,          // ǉ	0x1F "V"
    0b1000000,          // ǉ	0x20 "W"
    0b1110110,          // ǉ	0x21 "x"
    0b1000100,          // ǉ	0x22 "y"
    0b0010011,          // ǉ	0x23 "Z"
    0b1111110,          // ǉ	0x24 "-"
    0b1111111,          // ǉ	0x25 " "
    0b1110111,          // ǉ	0x26 "1"
    0b1110011,          // ǉ	0x27 "2"
    0b1110001,          // ǉ	0x28 "3"
    0b0110001,          // ǉ	0x29 "4"
    0b0111111,          // ǉ	0x2A "5"
    0b0011111,          // ǉ	0x2B "6"
    0b0001111,          // ǉ	0x2C "7"
    0b0000111,          // ǉ	0x2D "8"
    0b1011001          // ǉ	0x2E "i!" Hi!\p(DPKv)
};

struct SEG7{
	unsigned char HEX0;	// \p0ڂ̐l
	unsigned char HEX1;	// \p1ڂ̐l
	unsigned BIT:1;		// \̌(0`1)
	unsigned DP:2;		// \̏_(00`11)
} SEG7_REG;

void init(void){
	OSCCON = 0b01100101;
	//          | |||||____	1 = Internal oscillator is used for system clock
	//          | ||||_____	10=125k`8MHz 01=31kHz OSC Status
	//          | ||_______	OSTS 0=internal OSC
	//          |_|________	111=8MHz 100=1MHz 001=12kHz 000=31kHz
	
	CMCON0 = 0b00000111;	// Rp[^OFF
	TRISA0= 0;	// 0=out 1=in
	TRISA1= 0;	// 0=out 1=in
	TRISA2= 0;	// 0=out 1=in
	TRISA3= 1;	// 1=in (always)
	TRISA4= 0;	// 0=out 1=in
	TRISA5= 0;	// 0=out 1=in
	TRISC0= 0;	// 0=out 1=in
	TRISC1= 0;	// 0=out 1=in
	TRISC3= 0;	// 0=out 1=in
	TRISC4= 0;	// 0=out 1=in
	TRISC5= 0;	// 0=out 1=in
	WPUA = 0x00;	// vAbvȂ
	WPUA0 = 0;	// 0=Pull-up disabled 1=Pull-up
	WPUA1 = 0;	// 0=Pull-up disabled 1=Pull-up
	WPUA2 = 0;	// 0=Pull-up disabled 1=Pull-up
	WPUA4 = 0;	// 0=Pull-up disabled 1=Pull-up
	WPUA5 = 0;	// 0=Pull-up disabled 1=Pull-up
	ANS0  = 0;	// 0=digital 1=adc
	ANS1  = 0;	// 0=digital 1=adc
	ANS2  = 0;	// 0=digital 1=adc
	ANS3  = 0;	// 0=digital 1=adc
	ANS4  = 0;	// 0=digital 1=adc
	ANS5  = 0;	// 0=digital 1=adc
	ANS6  = 1;	// 0=digital 1=adc
	ANS7  = 0;	// 0=digital 1=adc
	ADCON0 = 0b00011011;
	//         || | |||____	ADON   = 1;	// ADC Enable bit 1=enabled 0=disabled
	//         || | ||_____	GODONE = 1;	// start the first conversion
	//         || |_|______	CHS    = 6     Analog Channel Select bits
	//         ||__________	VCFG   = 0;	// Voltage Reference bit : 1=VREF, 0=VDD
	//         |___________	ADFM   = 0;	// Result Format : justfified 0=left=0, 1=right
	ADCON1 = 0b01100000;	// ADC CLOCK PERIOD
	//          |_|________	ADCS 110 =ᑬ

	SEG7_P_a = 1;	// 1=off 0=on
	SEG7_P_b = 1;	// 1=off 0=on
	SEG7_P_c = 1;	// 1=off 0=on
	SEG7_P_d = 1;	// 1=off 0=on
	SEG7_P_e = 1;	// 1=off 0=on
	SEG7_P_f = 1;	// 1=off 0=on
	SEG7_P_g = 1;	// 1=off 0=on
	SEG7_P_dp= 1;	// 1=off 0=on
	SEG7_P_0 = 0;	// 0=off 1=on
	SEG7_P_1 = 0;	// 0=off 1=on

	SEG7_REG.HEX0	= 0x00;	// \p0ڂ̐l
	SEG7_REG.HEX1	= 0x00;	// \p1ڂ̐l
	SEG7_REG.BIT	= 0b0;	// \̌(0`1)
	SEG7_REG.DP		= 0b00;	// \̏_(00`11)

	// TIMER0 for LED Flash
	OPTION = 0b10000100;	// configure Timer0
	T0IF = 0;				// ensure Timer0 Interrupt flag is clear
	T0IE = 1;				// enable Timer0 interrupts
	ei();					// enable global interrupts
}

void seg7_seg_out( const unsigned char in ){
	SEG7_P_a = (LEDDigit[in] & 0b01000000)>>6;
	SEG7_P_b = (LEDDigit[in] & 0b00100000)>>5;
	SEG7_P_c = (LEDDigit[in] & 0b00010000)>>4;
	SEG7_P_d = (LEDDigit[in] & 0b00001000)>>3;
	SEG7_P_e = (LEDDigit[in] & 0b00000100)>>2;
	SEG7_P_f = (LEDDigit[in] & 0b00000010)>>1;
	SEG7_P_g = (LEDDigit[in] & 0b00000001);
}

void seg7_hex_flash(){
	if( SEG7_REG.BIT == 0b0 ){
		SEG7_P_0 = 0;
		SEG7_P_1 = 0;
		seg7_seg_out( SEG7_REG.HEX0 );
		SEG7_P_dp = !(SEG7_REG.DP & 0b01);
		SEG7_P_0 = 1;
		SEG7_REG.BIT = 0b1;
	}else {
		SEG7_P_1 = 0;
		SEG7_P_0 = 0;
		seg7_seg_out( SEG7_REG.HEX1 );
		SEG7_P_dp = !((SEG7_REG.DP & 0b10)>>1);
		SEG7_P_1 = 1;
		SEG7_REG.BIT = 0b0;
	}
}

void seg7_hex( const unsigned char in ){
	SEG7_REG.HEX0 = in%16;
	SEG7_REG.HEX1 = in/16;
	SEG7_REG.DP = 0b00;
}

unsigned char seg7_code( const unsigned char in ){
	
	if( in < 16 ) 					return( in );
	if( in >= '0' && in <= '9' )	return( in - '0' );
	if( in >= 'a' && in <= 'z' )	return( in - 'a' + 0x0A);
	if( in >= 'A' && in <= 'Z' )	return( in - 'A' + 0x0A);
	if( in == ' ' )					return( 0x25);	// Xy[X\
	return( 0x24 );									// "-"\
}

void seg7_char( const unsigned char *s ){
	SEG7_REG.HEX1 = seg7_code( *s++ );
	SEG7_REG.HEX0 = seg7_code( *s++ );
	SEG7_REG.DP = 0b00;
}

void seg7_char2( const unsigned char c1, const unsigned char c0 ){
	SEG7_REG.HEX0 = seg7_code( c0 );
	SEG7_REG.HEX1 = seg7_code( c1 );
	SEG7_REG.DP = 0b00;
}

void seg7_hi(void){
	SEG7_REG.HEX1 = seg7_code( 'H' );
	SEG7_REG.HEX0 = 0x2E;
	SEG7_REG.DP = 0b01;
}

void seg7_int( const unsigned char in ){
	SEG7_REG.HEX0 = in%10;
	if( in >= 160 ){
		seg7_char( "Er" );
	}else if( in < 10 && SEG7_REG.DP != 0b10 ){ // 10ȉ  łȂꍇ
		SEG7_REG.HEX1 = 0x25;	// null
	}else{
		SEG7_REG.HEX1 = in/10;
	}
	if( SEG7_REG.DP != 0b10 ){
		SEG7_REG.DP = 0b01;
	}
}

void seg7_float( const unsigned char in ){
	if( in<100 ){
		SEG7_REG.DP = 0b10;			// ͒l10/1 (%f1.1)\
		seg7_int( in );
	}else{
		SEG7_REG.DP = 0b01;
		seg7_int( in/10 );
	}
}

void seg7_level( const unsigned char in ){
	if( in <= 4){
		SEG7_REG.HEX1 = in + 0x25;
		SEG7_REG.HEX0 = 0x25;
	}else if( in <= 8 ){
		SEG7_REG.HEX1 = 0x29;	// "C"
		SEG7_REG.HEX0 = in + 0x25;
	}else{
		seg7_char( "Er" );
	}
	SEG7_REG.DP = 0b10;
}

void interrupt interrupt_service(void){
	if (T0IE && T0IF){					// Timer0 Interrupt
		seg7_hex_flash();
		T0IF = 0;						// clear Timer0 interrupt flag
	}
}

unsigned int adc( void ){
	unsigned int sum;
	unsigned char i;
	
	GODONE = 1;
	while( GODONE );
	sum=ADRESH;
	for( i=0 ; i<255 ; i++){
		while( GODONE );
		sum += ADRESH;
		GODONE = 1;
	}
	return( sum );
}

void demo_mode( const unsigned char mode ){
	unsigned char  i;
	
	switch( mode ){
		case 1:
			seg7_char( "VM" ); for( i=0 ; i< 100 ; i++) __delay_ms(10);
			for( i=0 ; i<50 ; i++){seg7_float( i ); __delay_ms(20);}
			break;
		case 2:
			seg7_char( "LV" ); for( i=0 ; i< 100 ; i++) __delay_ms(10);
			for( i=0 ; i<9 ; i++){seg7_level( i ); __delay_ms(100);}
			break;
		case 3:
			seg7_char( "HE" ); for( i=0 ; i< 100 ; i++) __delay_ms(10);
			for( i=0 ; i<255 ; i++){seg7_hex( i ); __delay_ms(4);}
			break;
		case 4:
			seg7_char( "in" ); for( i=0 ; i< 100 ; i++) __delay_ms(10);
			for( i=0 ; i<100 ; i++){seg7_int( i ); __delay_ms(10);}
			break;
		case 5:
			seg7_char( "15" ); for( i=0 ; i< 100 ; i++) __delay_ms(10);
			for( i=0 ; i<150 ; i++){seg7_float( i ); __delay_ms(7);}
			break;
		default:
			break;
	}
	
}

void main(void){
	unsigned char i;
	unsigned char mode;		// 0:d 1:HEX 2:int

	init();

	seg7_hi();
	for( i=0 ; i< 100 ; i++) __delay_ms(10);
	
	mode=eeprom_read(EEPROM_A_MODE);
	if( mode < 1 || mode > MODE_NUM ){
		mode=1;
		eeprom_write(EEPROM_A_MODE,mode);
	}
	demo_mode( mode );
	
	while(1){
		if( KEY_P == 0 ){
			for( i=0 ; i< 20 ; i++) __delay_ms(10);
			if( KEY_P ){
				mode++;
				if( mode > MODE_NUM ) mode = 1;
				seg7_char2( 'P', mode );
			}else{
				seg7_char( "EP" );
				eeprom_write(EEPROM_A_MODE,mode);
			}
			for( i=0 ; i< 20 ; i++) __delay_ms(10);
			while( KEY_P == 0 );
//			demo_mode( mode );
		}
		switch( mode ){
			case 1:
				/* d \ */
				seg7_float( adc()/1286 );
				break;
			case 2:
				/* Level\ */
				seg7_level( adc()/7282 );
				break;
			case 3:
				/* HEX\ */
				seg7_hex( adc()/256 );
				break;
			case 4:
				/* INT\ */
				seg7_int( adc()/655 );
				break;
			case 5:
				/* d 1/3 (15V5V in) \ */
				seg7_float( adc()/430 );
				break;
			default:
				break;
		}
	}
}
